diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/help.c tin-2.6.5/src/help.c
--- tin-2.6.4/src/help.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/help.c	2025-12-07 12:42:32.189790563 +0100
@@ -757,56 +794,76 @@ show_help_page(
 	const char *title)
 {
 	FILE *fp;
+	char help_file[PATH_LEN];
+	char tmp[PATH_LEN];
 
-	if (!(fp = my_tmpfile()))
-		return;
+	sprintf(tmp, HELP_PAGE_CACHE_FILE, level);
+	joinpath(help_file, sizeof(help_file), serverdir, tmp);
 
-	switch (level) {
-		case ATTACHMENT_LEVEL:
-			make_help_page(fp, attachment_help_page, attachment_keys);
-			break;
-
-		case ATTRIB_LEVEL:
-			make_help_page(fp, attrib_help_page, option_menu_keys);
-			break;
-
-		case CONFIG_LEVEL:
-			make_help_page(fp, config_help_page, option_menu_keys);
-			break;
-
-		case SCOPE_LEVEL:
-			make_help_page(fp, scope_help_page, scope_keys);
-			break;
-
-		case SELECT_LEVEL:
-			make_help_page(fp, select_help_page, select_keys);
-			break;
-
-		case GROUP_LEVEL:
-			make_help_page(fp, group_help_page, group_keys);
-			break;
-
-		case THREAD_LEVEL:
-			make_help_page(fp, thread_help_page, thread_keys);
-			break;
-
-		case PAGE_LEVEL:
-			make_help_page(fp, page_help_page, page_keys);
-			break;
-
-		case POSTED_LEVEL:
-			make_help_page(fp, post_hist_help_page, post_hist_keys);
-			break;
-
-		case URL_LEVEL:
-			make_help_page(fp, url_help_page, url_keys);
-			break;
-
-		case INFO_PAGER:
-		default: /* should not happen */
-			error_message(2, _(txt_error_unknown_dlevel));
-			fclose(fp);
+	/*
+	 * check if we have cached the help page already, if not create it
+	 *
+	 * TODO: remember which help-pages haven been created so we don't
+	 *       have to try (removal) based on the file,
+	 *       if (!(level & help_page_cached)) { ... }
+	 *       but that would be another global (so we can make use of it
+	 *       in cleanup_tmp_files())?
+	 */
+	if ((fp = fopen(help_file, "r")) == NULL) { /* ENOENT */
+		if ((fp = fopen(help_file, "w+")) == NULL) /* TODO: error message */
 			return;
+
+		switch (level) {
+			case ATTACHMENT_LEVEL:
+				make_help_page(fp, attachment_help_page, attachment_keys);
+				break;
+
+			case ATTRIB_LEVEL:
+				make_help_page(fp, attrib_help_page, option_menu_keys);
+				break;
+
+			case CONFIG_LEVEL:
+				make_help_page(fp, config_help_page, option_menu_keys);
+				break;
+
+			case SCOPE_LEVEL:
+				make_help_page(fp, scope_help_page, scope_keys);
+				break;
+
+			case SELECT_LEVEL:
+				make_help_page(fp, select_help_page, select_keys);
+				break;
+
+			case SERVERRC_LEVEL:
+				make_help_page(fp, serverrc_help_page, option_menu_keys);
+				break;
+
+			case GROUP_LEVEL:
+				make_help_page(fp, group_help_page, group_keys);
+				break;
+
+			case THREAD_LEVEL:
+				make_help_page(fp, thread_help_page, thread_keys);
+				break;
+
+			case PAGE_LEVEL:
+				make_help_page(fp, page_help_page, page_keys);
+				break;
+
+			case POSTED_LEVEL:
+				make_help_page(fp, post_hist_help_page, post_hist_keys);
+				break;
+
+			case URL_LEVEL:
+				make_help_page(fp, url_help_page, url_keys);
+				break;
+
+			case INFO_PAGER:
+			default: /* should not happen */
+				error_message(2, _(txt_error_unknown_dlevel));
+				fclose(fp);
+				return;
+		}
 	}
 
 	info_pager(fp, title, TRUE);
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/inews.c tin-2.6.5/src/inews.c
--- tin-2.6.4/src/inews.c	2024-12-05 04:31:45.000000000 +0100
+++ tin-2.6.5/src/inews.c	2025-12-18 19:48:54.522296575 +0100
@@ -3,10 +3,10 @@
  *  Module    : inews.c
  *  Author    : I. Lea
  *  Created   : 1992-03-17
- *  Updated   : 2024-12-05
+ *  Updated   : 2025-12-18
  *  Notes     : NNTP built in version of inews
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -50,7 +50,7 @@
  * local prototypes
  */
 #ifdef NNTP_INEWS
-	static t_bool submit_inews(const char *name, struct t_group *group, char *a_message_id);
+	static t_bool submit_inews(const char *name, const struct t_group *group, char *a_message_id);
 #endif /* NNTP_INEWS */
 #if defined(NNTP_INEWS) && !defined(FORGERY)
 	static int sender_needed(const char *from, const char *sender, const char *charset);
@@ -66,7 +66,7 @@
 static t_bool
 submit_inews(
 	const char *name,
-	struct t_group *group,
+	const struct t_group *group,
 	char *a_message_id)
 {
 	FILE *fp;
@@ -206,7 +206,7 @@ submit_inews(
 		 * Send POST command to NNTP server
 		 * Receive CONT_POST or ERROR response code from NNTP server
 		 */
-		if (nntp_command("POST", CONT_POST, response, sizeof(response)) == NULL) {
+		if (new_nntp_command("POST", CONT_POST, response, sizeof(response)) != CONT_POST) {
 			error_message(2, "%s", response);
 			fclose(fp);
 			goto out;
@@ -390,7 +390,7 @@ out:
 t_bool
 submit_news_file(
 	char *name,
-	struct t_group *group,
+	const struct t_group *group,
 	char *a_message_id)
 {
 	char buf[PATH_LEN];
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/init.c tin-2.6.5/src/init.c
--- tin-2.6.4/src/init.c	2024-12-21 15:17:27.000000000 +0100
+++ tin-2.6.5/src/init.c	2025-12-20 18:11:41.872091092 +0100
@@ -3,10 +3,10 @@
  *  Module    : init.c
  *  Author    : I. Lea
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-21
+ *  Updated   : 2025-12-20
  *  Notes     :
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -65,13 +65,17 @@ static int read_site_config(void);
 	static void preinit_colors(void);
 #endif /* HAVE_COLOR */
 
-
+#ifndef NNTP_ONLY
 char active_times_file[PATH_LEN];
+char overviewfmt_file[PATH_LEN];	/* full path to overview.fmt */
+char subscriptions_file[PATH_LEN];	/* full path to subscriptions */
+#endif /* !NNTP_ONLY */
+
 char article_name[PATH_LEN];			/* ~/TIN_ARTICLE_NAME file */
 char *backup_article_name;			/* ~/TIN_ARTICLE_NAME[.pid].b[ak] file */
 #ifdef NNTP_ABLE
-	char bug_nntpserver1[PATH_LEN];		/* welcome message of NNTP server used */
-	char bug_nntpserver2[PATH_LEN];		/* welcome message of NNTP server used */
+	char bug_nntpserver1[NNTP_STRLEN];		/* welcome message of NNTP server used */
+	char bug_nntpserver2[NNTP_STRLEN];		/* welcome message of NNTP server used */
 #endif /* NNTP_ABLE */
 char cvers[LEN];
 char dead_article[PATH_LEN];		/* ~/dead.article file */
@@ -111,13 +115,15 @@ char posted_info_file[PATH_LEN];
 char postponed_articles_file[PATH_LEN];	/* ~/.tin/postponed.articles file */
 char rcdir[PATH_LEN];
 char save_active_file[PATH_LEN];
+char serverrc_file[PATH_LEN];	/* ~/.tin/$NNTPSERVER/serverrc file */
 char spooldir[PATH_LEN];		/* directory where news is */
-char overviewfmt_file[PATH_LEN];	/* full path to overview.fmt */
-char subscriptions_file[PATH_LEN];	/* full path to subscriptions */
 char *tin_progname;		/* program name */
 const char *tmpdir;
 char txt_help_bug_report[LEN];		/* address to send bug reports to */
 char userid[LOGIN_NAME_MAX];
+#ifdef NNTPS_ABLE
+	time_t startup_time;
+#endif /* NNTPS_ABLE */
 #ifdef HAVE_MH_MAIL_HANDLING
 	char mail_active_file[PATH_LEN];
 	char mailgroups_file[PATH_LEN];
@@ -137,7 +143,7 @@ int iso2asc_supported;			/* Convert ISO-
 int system_status;
 int xmouse, xrow, xcol;			/* xterm button pressing information */
 
-long motd_hash = 0L;
+volatile sig_atomic_t pending_sactions;	/* pending sigactions */
 
 pid_t process_id;			/* Useful to have around for .suffixes */
 
@@ -180,7 +186,7 @@ t_bool xref_supported = TRUE;
 	t_bool force_auth_on_conn_open = FALSE;	/* authenticate on connection startup */
 	unsigned short nntp_tcp_port = 0;
 	unsigned short nntp_tcp_default_port;
-#if defined(USE_ZLIB) && defined(CPP_DOES_CONCAT)
+#ifdef USE_ZLIB
 	t_bool use_compress = FALSE;
 #endif /* USE_ZLIB */
 #ifdef NNTPS_ABLE
@@ -201,9 +207,13 @@ char *input_history[HIST_MAXNUM + 1][HIS
 struct regex_cache
 		strip_re_regex, strip_was_regex,
 		uubegin_regex, uubody_regex,
+		xxbody_regex,
 		verbatim_begin_regex, verbatim_end_regex,
+		hideline_regex,
+		yencbegin_regex, yencpart_regex, yencend_regex,
 		url_regex, mail_regex, news_regex,
-		shar_regex,
+		shar_regex, shar_end_regex,
+		latex_regex,
 		slashes_regex, stars_regex, underscores_regex, strokes_regex
 #ifdef HAVE_COLOR
 		, extquote_regex, quote_regex, quote_regex2, quote_regex3
@@ -212,6 +222,21 @@ struct regex_cache
 
 struct t_cmdlineopts cmdline = { 0, 0, NULL, NULL, NULL, NULL, 0 };
 
+struct t_serverrc serverrc = {
+#if 0
+	NULL,	/* version */
+	NULL,	/* last_newnews */
+#endif /* 0 */
+	NULL,	/* add_cmd_line_opts */
+	NULL,	/* disabled_nntp_cmds */
+	0L,	/* motd_hash */
+	PIPELINE_LIMIT_DEFAULT,	/* nntp_pipeline_limit */
+	FALSE,	/* cache_overview_files */
+#ifdef USE_ZLIB
+	FALSE,	/* compress_overview_files */
+#endif /* USE_ZLIB */
+};
+
 struct t_config tinrc = {
 	NULL,	/* default_goto_group */
 	NULL,	/* default_mail_address */
@@ -240,6 +265,7 @@ struct t_config tinrc = {
 	NULL,	/* attachment_format */
 	NULL,	/* page_mime_format */
 	NULL,	/* page_uue_format */
+	NULL,	/* page_yenc_format */
 	NULL,	/* date_format */
 	NULL,	/* mail_quote_format */
 	NULL,	/* mailer_format */
@@ -271,6 +297,7 @@ struct t_config tinrc = {
 	NULL,	/* underscores_regex */
 	NULL,	/* verbatim_begin_regex */
 	NULL,	/* verbatim_end_regex */
+	NULL,	/* hideline_regex */
 	NULL,	/* savedir */
 	NULL,	/* sigfile */
 	NULL,	/* spamtrap_warning_addresses */
@@ -329,7 +356,7 @@ struct t_config tinrc = {
 	'a',	/* default_save_mode */
 	0,		/* getart_limit */
 	GOTO_NEXT_UNREAD_TAB,		/* goto_next_unread */
-	UUE_NO,	/* hide_uue */
+	UUE_NO,	/* hide_inline_data */
 	INTERACTIVE_NONE,			/* interactive_mailer */
 	KILL_UNREAD,				/* kill_level */
 	2,		/* mono_markdash */
@@ -365,6 +392,7 @@ struct t_config tinrc = {
 	THREAD_PERC_DEFAULT,	/* thread_perc */
 	THREAD_SCORE_MAX,		/* thread_score */
 	0,		/* trim_article_body */
+	VERBATIM_SHOW_ALL,		/* verbatim_handling */
 	0,		/* Default to wildmat, not regex */
 	2,		/* word_h_display_marks */
 	0,		/* wrap_column */
@@ -382,9 +410,9 @@ struct t_config tinrc = {
 	TRUE,	/* beginner_level */
 	FALSE,	/* cache_overview_files */
 	FALSE,	/* catchup_read_groups */
-#if defined(USE_ZLIB) && defined(CPP_DOES_CONCAT)
+#ifdef USE_ZLIB
 	FALSE,	/* compress_overview_files */
-#endif /* USE_ZLIB && CPP_DOES_CONCAT */
+#endif /* USE_ZLIB */
 #ifdef USE_INVERSE_HACK
 	TRUE,	/* draw_arrow */
 #else
@@ -400,6 +428,7 @@ struct t_config tinrc = {
 	TRUE,	/* inverse_okay */
 #endif /* USE_INVERSE_HACK */
 	TRUE,	/* keep_dead_articles */
+	FALSE,	/* keep_expired_filters */
 	FALSE,	/* mail_8bit_header */
 	FALSE,	/* mark_ignore_tags */
 	TRUE,	/* mark_saved_read */
@@ -434,7 +463,6 @@ struct t_config tinrc = {
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 	FALSE,	/* utf8_graphics */
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
-	TRUE,	/* verbatim_handling */
 #ifdef HAVE_COLOR
 	FALSE,	/* extquote_handling */
 #endif /* HAVE_COLOR */
@@ -457,15 +485,19 @@ struct t_config tinrc = {
 	TRUE,	/* url_highlight */
 	TRUE,	/* word_highlight */
 	TRUE,	/* wrap_on_next_unread */
-	ART_MARK_DELETED,		/* art_marked_deleted */
-	MARK_INRANGE,			/* art_marked_inrange */
-	ART_MARK_RETURN,		/* art_marked_return */
-	ART_MARK_SELECTED,		/* art_marked_selected */
-	ART_MARK_RECENT,		/* art_marked_recent */
-	ART_MARK_UNREAD,		/* art_marked_unread */
-	ART_MARK_READ,			/* art_marked_read */
-	ART_MARK_KILLED,		/* art_marked_killed */
-	ART_MARK_READ_SELECTED,	/* art_marked_read_selected */
+	ART_MARK_DELETED,			/* art_marked_deleted */
+	MARK_INRANGE,				/* art_marked_inrange */
+	ART_MARK_RETURN,			/* art_marked_return */
+	ART_MARK_SELECTED,			/* art_marked_selected */
+	ART_MARK_RECENT,			/* art_marked_recent */
+	ART_MARK_UNREAD,			/* art_marked_unread */
+	ART_MARK_READ,				/* art_marked_read */
+	ART_MARK_KILLED,			/* art_marked_killed */
+	ART_MARK_READ_SELECTED,		/* art_marked_read_selected */
+	SCOPE_MARK_GLOBAL,			/* scope_marked_global */
+	SCOPE_MARK_GLOBAL_MATCH,	/* scope_marked_global_match */
+	SCOPE_MARK_LOCAL,			/* scope_marked_local */
+	SCOPE_MARK_LOCAL_MATCH,		/* scope_marked_local_match */
 	NULL,	/* attrib_editor_format */
 	NULL,	/* attrib_fcc */
 	NULL,	/* attrib_maildir */
@@ -498,7 +530,9 @@ struct t_config tinrc = {
 	FALSE,
 #	endif /* USE_ICU_UCSDET */
 #endif /* CHARSET_CONVERSION */
+	UUE_NO,	/* attrib_hide_inline_data */
 	0,		/* attrib_trim_article_body */
+	VERBATIM_SHOW_ALL,	/* attrib_verbatim_handling */
 	0,		/* attrib_auto_cc_bcc */
 	FILTER_SUBJ_CASE_SENSITIVE,		/* attrib_quick_kill_header */
 	FILTER_SUBJ_CASE_SENSITIVE,		/* attrib_quick_select_header */
@@ -510,6 +544,7 @@ struct t_config tinrc = {
 	SORT_THREADS_BY_SCORE_DESCEND,	/* attrib_sort_threads_type */
 	THREAD_BOTH,			/* attrib_thread_articles */
 	THREAD_PERC_DEFAULT,	/* attrib_thread_perc */
+	0,		/* attrib_getart_limit */
 	TRUE,	/* attrib_add_posted_to_filter */
 	TRUE,	/* attrib_advertising */
 	TRUE,	/* attrib_alternative_handling */
@@ -540,7 +575,6 @@ struct t_config tinrc = {
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 	FALSE,	/* attrib_tex2iso_conv */
 	TRUE,	/* attrib_thread_catchup_on_exit */
-	TRUE,	/* attrib_verbatim_handling */
 #ifdef HAVE_COLOR
 	FALSE,	/* attrib_extquote_handling */
 #endif /* HAVE_COLOR */
@@ -550,7 +584,14 @@ struct t_config tinrc = {
 	FALSE,	/* attrib_quick_kill_case */
 	FALSE,	/* attrib_quick_kill_expire */
 	FALSE,	/* attrib_quick_select_case */
-	FALSE	/* attrib_quick_select_expire */
+	FALSE,	/* attrib_quick_select_expire */
+	NULL,	/* serverrc_add_cmd_line_opts */
+	NULL,	/* serverrc_disabled_nntp_cmds */
+	PIPELINE_LIMIT_DEFAULT,	/* serverrc_nntp_pipeline_limit */
+	FALSE	/* serverrc_cache_overview_files */
+#	ifdef USE_ZLIB
+	, FALSE	/* serverrc_compress_overview_files */
+#	endif /* USE_ZLIB */
 };
 
 struct t_capabilities nntp_caps = {
@@ -559,26 +600,30 @@ struct t_capabilities nntp_caps = {
 	FALSE, /* MODE-READER: "MODE READER" */
 	FALSE, /* READER: "ARTICLE", "BODY" */
 	FALSE, /* POST */
-	FALSE, /* LIST: "LIST ACTIVE" */
+	TRUE, /* LIST: "LIST ACTIVE" */
 	FALSE, /* LIST: "LIST ACTIVE.TIMES" */
-	FALSE, /* LIST: "LIST DISTRIB.PATS" */
+	TRUE, /* LIST: "LIST DISTRIB.PATS" */
 	FALSE, /* LIST: "LIST HEADERS" */
 	NULL, /* list of headers by range */
 	NULL, /* list of headers by id */
-	FALSE, /* LIST: "LIST NEWSGROUPS" */
-	FALSE, /* LIST: "LIST OVERVIEW.FMT" */
-	FALSE, /* LIST: "LIST MOTD" */
-	FALSE, /* LIST: "LIST SUBSCRIPTIONS" */
-	FALSE, /* LIST: "LIST DISTRIBUTIONS" */
+	TRUE, /* LIST: "LIST NEWSGROUPS" */
+	TRUE, /* LIST: "LIST OVERVIEW.FMT" */
+	TRUE, /* LIST: "LIST MOTD" */
+	TRUE, /* LIST: "LIST SUBSCRIPTIONS" */
+	TRUE, /* LIST: "LIST DISTRIBUTIONS" */
 	FALSE, /* LIST: "LIST MODERATORS" */
 	FALSE, /* LIST: "LIST COUNTS" */
-	FALSE, /* XPAT */
-	FALSE, /* HDR: "HDR", "LIST HEADERS" */
+	TRUE, /* LISTGROUP */
+	TRUE, /* XPAT */
+	TRUE, /* HDR: "HDR", "LIST HEADERS" */
 	NULL, /* [X]HDR */
-	FALSE, /* OVER: "OVER", "LIST OVERVIEW.FMT" */
+	TRUE, /* OVER: "OVER", "LIST OVERVIEW.FMT" */
 	FALSE, /* OVER: "OVER mid" */
 	NULL, /* [X]OVER */
+	TRUE, /* NEWGROUPS */
+#if 0
 	FALSE, /* NEWNEWS */
+#endif /* 0 */
 	NULL, /* IMPLEMENTATION */
 	FALSE, /* STARTTLS */
 	FALSE, /* AUTHINFO USER/PASS */
@@ -588,18 +633,14 @@ struct t_capabilities nntp_caps = {
 	NULL, /* SASL mech used after handshake */
 	FALSE, /* COMPRESS */
 	COMPRESS_NONE, /* COMPRESS_NONE, COMPRESS_DEFLATE */
+	NULL,	/* DISTRIB.PATS linked list */
 #if defined(MAXARTNUM) && defined(USE_LONG_ARTICLE_NUMBERS)
 	T_ARTNUM_CONST(0), /* MAXARTNUM */
 #endif /* MAXARTNUM && USE_LONG_ARTICLE_NUMBERS */
 #if 0
 	FALSE, /* STREAMING: "MODE STREAM", "CHECK", "TAKETHIS" */
-	FALSE /* IHAVE */
+	FALSE, /* IHAVE */
 #endif /* 0 */
-#ifndef BROKEN_LISTGROUP
-	FALSE /* LISTGROUP doesn't select group */
-#else
-	TRUE
-#endif /* !BROKEN_LISTGROUP */
 };
 
 static char libdir[PATH_LEN];			/* directory where news config files are (ie. active) */
@@ -714,6 +755,12 @@ init_selfinfo(
 	} else
 		my_strncpy(userid, myentry->pw_name, sizeof(userid) - 1);
 
+	pending_sactions = 0;
+
+#ifdef NNTPS_ABLE
+	(void) time(&startup_time); /* issue warning on error? */
+#endif /* NNTPS_ABLE */
+
 	*domain_name = '\0';
 
 #ifdef HAVE_SYS_UTSNAME_H
@@ -744,7 +791,7 @@ init_selfinfo(
 
 	if ((p = get_val("TIN_HOMEDIR", get_val("HOME", NULL))) != NULL) {
 		my_strncpy(homedir, p, sizeof(homedir) - 1);
-	} else if (strlen(myentry->pw_dir)) {
+	} else if (*myentry->pw_dir) {
 		strncpy(homedir, myentry->pw_dir, sizeof(homedir) - 1);
 	} else
 		strncpy(homedir, tmpdir, sizeof(homedir) - 1);
@@ -753,9 +800,26 @@ init_selfinfo(
 	dangerous_signal_exit = FALSE;
 	disable_gnksa_domain_check = TRUE;
 	disable_sender = FALSE;	/* we set force_no_post=TRUE later on if we don't have a valid FQDN */
-	iso2asc_supported = s2i(get_val("ISO2ASC", DEFAULT_ISO2ASC), -1, NUM_ISO_TABLES - 1);
-	if (errno) /* TODO: issue a warning here? */
-		iso2asc_supported = -1;
+	p = get_val("ISO2ASC", DEFAULT_ISO2ASC);
+	iso2asc_supported = s2i(p, -1, NUM_ISO_TABLES - 1);
+	switch (errno) {
+		case EINVAL:
+			error_message(0, _(txt_arg_not_numeric), "$ISO2ASC", p);
+			if (!batch_mode)
+				sleep(2);
+			iso2asc_supported = -1;
+			break;
+
+		case ERANGE:
+			error_message(0, _(txt_val_out_of_range_ignored), "$ISO2ASC", p, -1, NUM_ISO_TABLES - 1);
+			if (!batch_mode)
+				sleep(2);
+			iso2asc_supported = -1;
+			break;
+
+		default:
+			break;
+	}
 	list_active = FALSE;
 	newsrc_active = FALSE;
 	post_article_and_exit = FALSE;
@@ -813,13 +877,13 @@ init_selfinfo(
 	my_strncpy(novrootdir, get_val("TIN_NOVROOTDIR", NOVROOTDIR), sizeof(novrootdir) - 1);
 	my_strncpy(novfilename, get_val("TIN_NOVFILENAME", OVERVIEW_FILE), sizeof(novfilename) - 1);
 	my_strncpy(spooldir, get_val("TIN_SPOOLDIR", SPOOLDIR), sizeof(spooldir) - 1);
-#endif /* !NNTP_ONLY */
-	/* clear news_active_file, active_time_file, newsgroups_file */
-	news_active_file[0] = '\0';
 	active_times_file[0] = '\0';
-	newsgroups_file[0] = '\0';
 	overviewfmt_file[0] = '\0';
 	subscriptions_file[0] = '\0';
+#endif /* !NNTP_ONLY */
+	/* clear news_active_file, newsgroups_file */
+	news_active_file[0] = '\0';
+	newsgroups_file[0] = '\0';
 
 	/*
 	 * read the global site config file to override some default
@@ -857,18 +921,18 @@ init_selfinfo(
 	}
 	if (!*active_times_file)
 		joinpath(active_times_file, sizeof(active_times_file), libdir, ACTIVE_TIMES_FILE);
-	if (!*newsgroups_file)
-		joinpath(newsgroups_file, sizeof(newsgroups_file), libdir, NEWSGROUPS_FILE);
-	if (!*subscriptions_file)
-		joinpath(subscriptions_file, sizeof(subscriptions_file), libdir, SUBSCRIPTIONS_FILE);
 	if (!*overviewfmt_file)
 		joinpath(overviewfmt_file, sizeof(overviewfmt_file), libdir, OVERVIEW_FMT);
+	if (!*subscriptions_file)
+		joinpath(subscriptions_file, sizeof(subscriptions_file), libdir, SUBSCRIPTIONS_FILE);
+	if (!*newsgroups_file)
+		joinpath(newsgroups_file, sizeof(newsgroups_file), libdir, NEWSGROUPS_FILE);
 	if (!default_organization || !*default_organization) {
 		joinpath(tmp, sizeof(tmp), libdir, "organization");
 		if ((fp = tin_fopen(tmp, "r")) != NULL) {
 			char buf[LEN];
 
-			if (fgets(buf, (int) sizeof(buf), fp) != NULL) {
+			if (fgets(buf, sizeof(buf), fp) != NULL) {
 				if ((ptr = strrchr(buf, '\n')) != NULL)
 					*ptr = '\0';
 			}
@@ -878,7 +942,7 @@ init_selfinfo(
 			default_organization = my_strdup(buf);
 		}
 	}
-#endif /* NNTP_ONLY */
+#endif /* !NNTP_ONLY */
 
 	/*
 	 * Formerly get_mm_charset(), read_site_config() may set mm_charset
@@ -900,15 +964,13 @@ init_selfinfo(
 				/* fallback to MM_CHARSET */
 				snprintf(ptr, space, "mm_network_charset=%s\n", MM_CHARSET);
 				if (!match_list(ptr, "mm_network_charset=", txt_mime_charsets, &tinrc.mm_network_charset))
-					/* fallback to US-ASCII */
-					tinrc.mm_network_charset = 0;
+					tinrc.mm_network_charset = 0; /* fallback to US-ASCII */
 			}
 		} else {
-				/* fallback to MM_CHARSET */
-				snprintf(ptr, space, "mm_network_charset=%s\n", MM_CHARSET);
-				if (!match_list(ptr, "mm_network_charset=", txt_mime_charsets, &tinrc.mm_network_charset))
-					/* fallback to US-ASCII */
-					tinrc.mm_network_charset = 0;
+			/* fallback to MM_CHARSET */
+			snprintf(ptr, space, "mm_network_charset=%s\n", MM_CHARSET);
+			if (!match_list(ptr, "mm_network_charset=", txt_mime_charsets, &tinrc.mm_network_charset))
+				tinrc.mm_network_charset = 0; /* fallback to US-ASCII */
 		}
 		free(ptr);
 	}
@@ -963,6 +1025,7 @@ init_selfinfo(
 	tinrc.attachment_format = my_strdup(DEFAULT_ATTACHMENT_FORMAT);
 	tinrc.page_mime_format = my_strdup(DEFAULT_PAGE_MIME_FORMAT);
 	tinrc.page_uue_format = my_strdup(DEFAULT_PAGE_UUE_FORMAT);
+	tinrc.page_yenc_format = my_strdup(DEFAULT_PAGE_YENC_FORMAT);
 	tinrc.date_format = my_strdup(DEFAULT_DATE_FORMAT);
 	joinpath(article_name, sizeof(article_name), homedir, TIN_ARTICLE_NAME);
 #ifdef APPEND_PID
@@ -970,9 +1033,9 @@ init_selfinfo(
 #endif /* APPEND_PID */
 
 #ifdef HAVE_LONG_FILE_NAMES
-	space = snprintf(NULL, 0, "%s.bak", article_name);
+	space = (size_t) snprintf(NULL, 0, "%s.bak", article_name);
 #else
-	space = snprintf(NULL, 0, "%s.b", article_name);
+	space = (size_t) snprintf(NULL, 0, "%s.b", article_name);
 #endif /* HAVE_LONG_FILE_NAMES */
 	backup_article_name = my_malloc(++space);
 #ifdef HAVE_LONG_FILE_NAMES
@@ -1019,7 +1082,7 @@ init_selfinfo(
 #ifdef HAVE_MH_MAIL_HANDLING
 	joinpath(mail_active_file, sizeof(mail_active_file), rcdir, ACTIVE_MAIL_FILE);
 #endif /* HAVE_MH_MAIL_HANDLING */
-	if ((p = get_val("MAILPATH", get_val("MAIL", NULL))) != NULL) {
+	if ((p = get_val("MAILPATH", get_val("MAIL", get_val("MAILDIR", NULL)))) != NULL) {
 		STRCPY(mailbox, p);
 	} else
 		joinpath(mailbox, sizeof(mailbox), DEFAULT_MAILBOX, userid);
@@ -1117,6 +1180,12 @@ read_site_config(
 	if (!fp)
 		return -1;
 
+	/*
+	 * no (_(txt_reading_(global_)config_file), global_defaults_file)
+	 * here as read_site_config() is called (from init_selfinfo()) before
+	 * read_cmd_line_options() so we don't know if we're in (verbose)
+	 * batch mode or not ...
+	 */
 	while ((buf = tin_fgets(fp, FALSE)) != NULL) {
 		/* ignore comments */
 		if (*buf == '#' || *buf == ';' || *buf == ' ')
@@ -1128,19 +1197,19 @@ read_site_config(
 			continue;
 		if (match_string(buf, "overviewfile=", novfilename, sizeof(novfilename)))
 			continue;
+		if (match_string(buf, "activetimesfile=", active_times_file, sizeof(active_times_file)))
+			continue;
+		if (match_string(buf, "overviewfmtfile=", overviewfmt_file, sizeof(overviewfmt_file)))
+			continue;
+		if (match_string(buf, "subscriptionsfile=", subscriptions_file, sizeof(subscriptions_file)))
+			continue;
 #endif /* !NNTP_ONLY */
 		if (match_string(buf, "activefile=", news_active_file, sizeof(news_active_file)))
 			continue;
-		if (match_string(buf, "activetimesfile=", active_times_file, sizeof(active_times_file)))
-			continue;
 		if (match_string(buf, "newsgroupsfile=", newsgroups_file, sizeof(newsgroups_file)))
 			continue;
 		if (match_string(buf, "newslibdir=", libdir, sizeof(libdir)))
 			continue;
-		if (match_string(buf, "subscriptionsfile=", subscriptions_file, sizeof(subscriptions_file)))
-			continue;
-		if (match_string(buf, "overviewfmtfile=", overviewfmt_file, sizeof(overviewfmt_file)))
-			continue;
 		if (match_string(buf, "domainname=", domain_name, sizeof(domain_name)))
 			continue;
 		if (match_string(buf, "inewsdir=", inewsdir, sizeof(inewsdir)))
@@ -1271,9 +1340,23 @@ postinit_regexp(
 	compile_regex(UUBEGIN_REGEX, &uubegin_regex, REGEX_ANCHORED);
 	compile_regex(UUBODY_REGEX, &uubody_regex, REGEX_ANCHORED);
 
+	compile_regex(XXBODY_REGEX, &xxbody_regex, REGEX_CASELESS|REGEX_ANCHORED);
+
+	if (!tinrc.hideline_regex || !*tinrc.hideline_regex) {
+		FreeIfNeeded(tinrc.hideline_regex);
+		tinrc.hideline_regex = my_strdup(NEVER_MATCH_REGEX);
+	}
+	compile_regex(tinrc.hideline_regex, &hideline_regex, 0);
+
+	compile_regex(YENCBEGIN_REGEX, &yencbegin_regex, REGEX_ANCHORED);
+	compile_regex(YENCPART_REGEX, &yencpart_regex, REGEX_ANCHORED);
+	compile_regex(YENCEND_REGEX, &yencend_regex, REGEX_ANCHORED);
+
 	compile_regex(URL_REGEX, &url_regex, REGEX_CASELESS);
 	compile_regex(MAIL_REGEX, &mail_regex, REGEX_CASELESS);
 	compile_regex(NEWS_REGEX, &news_regex, REGEX_CASELESS);
 
 	compile_regex(SHAR_REGEX, &shar_regex, REGEX_ANCHORED);
+	compile_regex(SHAR_END_REGEX, &shar_end_regex, REGEX_ANCHORED);
+	compile_regex(LATEX_REGEX, &latex_regex, 0);
 }
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/joinpath.c tin-2.6.5/src/joinpath.c
--- tin-2.6.4/src/joinpath.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/joinpath.c	2025-11-13 02:21:32.432173537 +0100
@@ -6,7 +6,7 @@
  *  Updated   : 2008-12-04
  *  Notes     :
  *
- * Copyright (c) 1997-2025 Thomas Dickey <dickey@invisible-island.net>
+ * Copyright (c) 1997-2026 Thomas Dickey <dickey@invisible-island.net>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
